import java.util.*;
public class Main {
    public static int count = 0;

    public static void main(String[] args) {
        printNums();  // Comment out to see the choose-explore-unchoose version!
        // printNumsCEU();
        System.out.println("Total # of combinations: " + count);
    }

    // Prints out all 3-digit combinations of
    // 1, 2, and 3
    public static void printNums() {
        printNums("");
    }

    private static void printNums(String soFar) {
        if (soFar.length() == 3) {
            count++;
            System.out.println(soFar);
        } else {
            printNums(soFar+ "1");
            printNums(soFar+ "2");
            printNums(soFar+ "3");
        }
    }

    // Prints out all 3-digit combinations of
    // 1, 2, and 3 using the
    // choose-explore-unchoose pattern
    public static void printNumsCEU() {
        printNumsCEU(new ArrayList<Integer>());
    }

    private static void printNumsCEU(List<Integer> chosen) {
        if (chosen.size() == 3) {
            count++;
            System.out.println(chosen);
        } else {
            for (int i = 1; i <= 3; i++) {  // for all possible choices
                chosen.add(i);                       // choose
                printNumsCEU(chosen);                // explore
                chosen.remove(chosen.size() - 1);    // unchoose
            }
        }
    }
}
